const express = require('express');
const mysql = require('mysql2');
const basicAuth = require('express-basic-auth');
const bodyParser = require('body-parser');

// Create an Express application
const app = express();
const port = 4000;

// Set up the MySQL connection
const db = mysql.createConnection({
  host: 'localhost', // Replace with your database host
  user: 'root',      // Replace with your database username
  password: '',      // Replace with your database password
  database: 'api' // Replace with your database name
});

// Connect to the database
db.connect((err) => {
  if (err) {
    console.error('Error connecting to the database:', err);
    return;
  }
  console.log('Connected to the MySQL database.');
});

// Set up basic authentication
app.use(basicAuth({
  users: { 'dev_wsl': 'dewjdfufuissweetfjdhfjdhjsiaueriptpjupgkoajit9040ejdfikjx' }, // Replace with your desired username and password
  challenge: true, // Enables the browser prompt for credentials
}));
app.use(bodyParser.urlencoded({ extended: true }));
app.use(bodyParser.json());


// Define a route to fetch data
app.get('/data', (req, res) => {
  const query = 'SELECT * FROM data_football'; // Replace with your table name

  db.query(query, (err, results) => {
    if (err) {
      console.error('Error fetching data:', err);
      res.status(500).json({ error: 'Database query error' });
      return;
    }

    // Send the results as JSON
    res.json(results);
  });
});

// Define a route to render a form for adding data
app.get('/add-data', (req, res) => {
    res.send(`
      <form action="/add-data" method="POST">
        <label for="league">League:</label><br>
        <input type="text" id="league" name="league" required><br><br>
  
        <label for="away">Away Team:</label><br>
        <input type="text" id="away" name="away" required><br><br>
  
        <label for="home">Home Team:</label><br>
        <input type="text" id="home" name="home" required><br><br>
  
        <label for="date">Date:</label><br>
        <input type="date" id="date" name="date" required><br><br>
  
        <label for="time">Time:</label><br>
        <input type="time" id="time" name="time" required><br><br>
  
        <label for="score">Score:</label><br>
        <input type="text" id="score" name="score"><br><br>
  
        <button type="submit">Submit</button>
      </form>
    `);
  });
  
  // Define a route to handle form submissions
  app.post('/add-data', (req, res) => {
    const { league, away, home, date, time, score } = req.body;
  
    const query = 'INSERT INTO data_football (league, away, home, date, time, score) VALUES (?, ?, ?, ?, ?, ?)';
    db.query(query, [league, away, home, date, time, score], (err, results) => {
      if (err) {
        console.error('Error inserting data:', err);
        res.status(500).send('Error inserting data');
        return;
      }
  
      res.send('Data successfully added!');
    });
  });


  

// Start the server
app.listen(port, () => {
  console.log(`Server is running on http://localhost:${port}`);
});